#ifndef _BOARD_H
#define _BOARD_H

#include "engine.h"
#include "board.h"
#include "opening.h"

#define COMPRESSED_BOARD_SIZE		17

#define BALLADE_EMPTY		0
#define BALLADE_ME			1
#define BALLADE_YOU			2
#define BALLADE_OUTSIDE		4
#define BALLADE_PASS		0

#define	BALLADE_MAX_BOARD	128
#define	BALLADE_BOARD_SIZE	( BALLADE_MAX_BOARD - sizeof( short ) * 4 )

#define ERROR_SUICIDE	100
#define ERROR_KO		101
#define ERROR_KOMA		102

typedef unsigned char	uchar;
typedef unsigned short	ushort;

typedef
  struct {
	long			sum;
	unsigned long	n;
  }
Score;

typedef
  struct {
    int   score;
	short move;
  }
MoveList;

typedef
  struct {
	uchar board[ BALLADE_BOARD_SIZE ];
	short capturedStones[ 2 ];
	short ko;
	short pass;
  }
TotalBoard;

class cboard {
 public:
  uchar mBoard[ BALLADE_MAX_BOARD ];
  char	mNeighbour[ 4 ];
  char	mSize;
  int pCapturedStone;
  short mCapturedStone[ BALLADE_MAX_BOARD ];
  uchar mCompressed[ COMPRESSED_BOARD_SIZE ];
  int	mCompressRotate;
  int	mCompressMirror;

 public:
  bool init( int size );
  int put( int stone, int pos );
  short think( /*COLOR colorBoard[ MAX_BOARD ][ MAX_BOARD ],*/
			  int iSize,
			  COLOR color );
  int ply( int stone,
		   uchar *board );
  int ply_first( int stone,
				 uchar *board,
				 Score *pscore,
				 int nmoves,
				 short *moves,
				 unsigned long nPlayout );
  int playout( int p_stone,
			   uchar *board,
			   short *history,
			   Score *pscore,
			   int nmoves,
			   short *moves,
			   unsigned long nPlayout );
  MoveList mc( void );
  short liberty( uchar *board,
				 short pos );
  bool canPut( int    me,
			   int    pos,
			   uchar* board );
  bool canPut1( int    me,
				int    pos,
				uchar* board );
  int put2( uchar *board,
			int stone,
			int pos );
  short liberty1( uchar *board, short pos );
  bool suicide( uchar *board, short pos, int stone );
  int get( unsigned char *board,
		   int            pos );
  short getAll( uchar *board,
				short pos,
				int   stone );
  bool	rotate( unsigned char *board0,
				unsigned char *board1 );
  bool	mirror( unsigned char *board0,
				unsigned char *board1 );
  bool	compress( void );
  bool	compressCore( unsigned char *board0,
					  unsigned char *board1 );
  bool invRotMir( int x, int y, int rot, int mir, int *x1, int *y1 );
};

#endif /* _BOARD_H */
