#include <stdio.h>
#include <memory.h>
#include "opening.h"

bool copening::init( void ) {
  // --- read opening book
  FILE *fp;
  fopen_s( &fp, OPENING_BOOK_BINARY_FILE, "rb" );

  if ( fp == NULL )
	return false;
  for ( m_nbook = 0; true; m_nbook++ ) {
	if ( m_nbook >= OPENING_BOOK_SIZE )
	  return false;
	if ( fread( &m_book[ m_nbook ], sizeof( OpeningBook ), 1, fp ) == 0 )
	  break;
  }

  fclose( fp );

  return true;
}

int copening::find( unsigned char *compressed ) {
  if ( m_nbook <= 0 )
	return -1;

  int low = 0;
  int high = m_nbook;

  while ( true ) {
	int mid = ( low + high ) / 2;
	int result = memcmp( compressed,
						 m_book[ mid ].compressed,
						 COMPRESSED_BOARD_SIZE );
	if ( result == 0 )
	  return mid;
	else if ( result < 0 ) {
	  high = mid;
	} else {
	  low = mid + 1;
	}
	if ( low >= high )
	  return -1;
  }
}
